unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, db, memds, SQLite3Conn, SQLDB, FileUtil, Forms,
  Controls, Graphics, Dialogs, DBGrids, Grids, StdCtrls, ComCtrls,
  uExtendedDbGrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    DBGrid1: TDBGrid;
    PageControl1: TPageControl;
    SQLite3Connection1: TSQLite3Connection;
    Q_Persone: TSQLQuery;
    Q_StatiConiugali: TSQLQuery;
    Q_Sesso: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    TabSheet1: TTabSheet;
    DataSource1: TDataSource;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure ComboBox1EditingDone(Sender: TObject);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: char);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure Edit1EditingDone(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure KDBGrid1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
         mycont: integer;
         procedure MyTextTitleChange(Sender: TObject; aCol: integer; aFieldName: string; aValue: string);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;

  function GetApplicationLocation(): string;
  var
    percorso: string;
  begin
       percorso:=Application.Location;
       {$IFDEF Darwin}
               percorso:=Application.Location + '../../../';
       {$ENDIF}
       Result:=percorso;
  end;

begin

   mycont:=0;


   Self.SQLite3Connection1.databasename:=GetApplicationLocation() + 'test.db';
   Self.SQLite3Connection1.Open;

   Self.Q_Sesso.SQL.Text:='select * from t_sesso;';
   Self.Q_Sesso.Open;

   Self.Q_StatiConiugali.SQL.Text:='select * from t_staticoniugali;';
   Self.Q_StatiConiugali.Open;

   Self.Q_Persone.SQL.Text:='select * from t_persone;';
   Self.Q_Persone.Open;

   Self.DBGrid1.SmartFilter:=true;
   Self.DBGrid1.TextFilter:=true;
   Self.DBGrid1.OnTextFilterChange:=@MyTextTitleChange;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     Self.Q_Persone.Close;
     Self.Q_StatiConiugali.Close;
     Self.Q_Sesso.Close;
     Self.SQLite3Connection1.Close;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
end;

procedure TForm1.KDBGrid1Click(Sender: TObject);
begin
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin

end;

procedure TForm1.MyTextTitleChange(Sender: TObject; aCol: integer;
  aFieldName: string; aValue: string);
var
  testo : string;
  i     : integer;
  j     : integer;
  lCol  : integer;
begin
     testo:='';

     if dgIndicator in Self.DBGrid1.Options then
     begin
        lCol:=1;
        j:=0;
     end
     else
     begin
         lCol:=0;
         j:=1;
     end;


     for i:=lCol to Self.DBGrid1.Columns.Count-j do
         testo := testo + ' - ' + Self.DBGrid1.GetFilterText(i);
     Self.Caption:= testo;
end;

procedure TForm1.DBGrid1TitleClick(Column: TColumn);
begin
     if Self.DBGrid1.LastMouseDown_Is_Title_Button then
     begin
          ShowMessage('Hai cliccato sul pulsante nel titolo del campo ' + Column.FieldName);
     end;
end;

procedure TForm1.Edit1EditingDone(Sender: TObject);
begin

end;

procedure TForm1.Edit1Enter(Sender: TObject);
begin

end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin

end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin

end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin



end;

procedure TForm1.ComboBox1Enter(Sender: TObject);
begin

end;

procedure TForm1.ComboBox1EditingDone(Sender: TObject);
begin

end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     Self.DBGrid1.InitColumnDBCombo();
     Self.DBGrid1.SetColumnDBCombo('__stato__', 'id_sc',Self.Q_StatiConiugali,'id','descrizione');
     Self.DBGrid1.SetColumnDBCombo('__sesso__', 'id_sesso',Self.Q_Sesso,'id','descrizione');
     Self.DBGrid1.UpdateColumnDBCombo();

     Self.DBGrid1.SetAlternateColor(clGreen);
     Self.DBGrid1.SetTitleCaption(3,'-');
     Self.DBGrid1.SetCheckColumn(3,'1','0');

     Self.q_persone.Last;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Self.q_persone.Last;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   i: integer;
begin
  Self.Q_Persone.Close;
  Self.Q_Persone.Open;

  Self.Q_Persone.Refresh;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     Self.Q_Persone.Refresh;
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: char);
begin


end;


end.

